# -*- coding: UTF-8 -*-
from django.conf import settings
from django.utils.translation import ugettext as _
#from ihx.access.base import definitions, constants, fields, functions
from ihx.access.core.MODPessoa import forms as forms_pessoa
from ihx.access.core.MODControle import forms as MODControleCore_forms


class mensalista_form(forms_pessoa.pessoafisica_form):
    group_info_pessoais = [(_(u'Informações pessoais'), {'fields': ['pessoafisicadatanascimento', 'pessoafisicasexo', 'pessoafisicaestadocivil',
                            'pessoafisicaescolaridade', 'cidadeid_naturalidade'], 'classes': ['grp-collapse grp-open']}), ]
    group_def_acesso = [(_(u'Definições de acesso'), {'fields': ['crachacodigo', 'pessoadupla'],
                            'classes': ['grp-collapse grp-open']}), ]
    raw_id_fields = ('cidadeid_naturalidade', 'crachacodigo')
    related_lookup_fields = {'fk': ['cidadeid_naturalidade', ''], }

    def __init__(self, *args, **kwargs):
        super(mensalista_form, self).__init__(*args, **kwargs)
        self.fieldsets = self.group_default + self.group_info_pessoais + self.group_info_adicionais + \
                         self.group_listanegra + self.group_observacao + self.group_notificacao + self.group_def_acesso


class contratoParking_form(MODControleCore_forms.contrato_form):
    permitir_edicao = True
    inlines = [MODControleCore_forms.contrato_formapagamento_inline, MODControleCore_forms.contrato_dependente_inline]

    class Media:
        css = {'all': (settings.MEDIA_URL + 'css/edit_contrato.css', )}
        js = (
            settings.MEDIA_URL + 'js/change_url_pessoa.js',
        )

    def get_form(self, request, obj=None, **kwargs):
        self.readonly_fields = []
        if (obj):
            self.readonly_fields = self.model._meta.get_all_field_names()
            if obj.planoid.regraplanorecorrencia:
                self.readonly_fields.remove('diavencimento')
                self.readonly_fields.remove('bloquearinadimplente')
        return super(contratoParking_form, self).get_form(request, obj, **kwargs)