# -*- coding: UTF-8 -*-
from datetime import time, datetime, timedelta
from django.db import transaction
from django.contrib.admin.models import LogEntry, ADDITION, CHANGE
from django.contrib.contenttypes.models import ContentType
from django.contrib.auth.decorators import login_required
from django.shortcuts import render_to_response, render
from django.http import HttpResponse, HttpResponseRedirect
from django.conf import settings
from django.views.decorators.csrf import csrf_exempt
from ihx.access.base import functions, constants
from ihx.access.core.MODControle.models import planofidelidade
from app.modules.MODTarifa.models import prktarifaclasse, prkticket, prkticket_mensagem
from reportlab.lib.units import cm


@transaction.commit_on_success
@csrf_exempt
@login_required(login_url='/')
def pagamento(request, *args):
    error = []
    mensagem = u''
    dictRetorno = {}
    fail = False
    primeira_entrada = True
    retorno = request.POST
    vTicket = None
    vAgora = datetime.today()
    vFormaPagamento = constants.FINFORMAPAGAMENTO
    try:
        if retorno:
            primeira_entrada = False
        for key, item in request.POST.items():
            if (key in ['valorpago']) and item == '':
                fail = True
                mensagem = u"o campo %s é obrigatório" % key.upper()
                error.append(key)
            else:
                if key == 'valorpago':
                    vValorPago = item.replace(".", "").replace(",", ".").replace("R$ ", "")
                    #vValorPago = item.replace(",", ".")
                    if retorno['valor_ticket'] and float(vValorPago) < float(retorno['valor_ticket'].replace(',', '.')):
                        fail = True
                        mensagem = u"o valor não pode ser MENOR ao do TICKET CALCULADO"
                        error.append(key)

        if 'codigoticket'in request.POST:
            qs_ticket = prkticket.objects.filter(codigo=retorno['codigoticket'].strip())
            if qs_ticket.count() == 0 or request.POST['codigoticket'] == '':
                fail = True
                mensagem = u"TICKET não cadastrado!"
                error.append('codigoticket')
            else:
                vTicket = qs_ticket[0]
                if vTicket.dtpagamento and vTicket.multiploacessodia:
                    fail = True
                    mensagem = u"Este TICKET não pode ser pago, ja foi pago a DIÁRIA"
                    error.append('codigoticket')
                if vTicket.dtpagamento and vTicket.tolerancia >= vAgora:
                    fail = True
                    mensagem = u"Este TICKET está dentro da permanência ate: %s " % vTicket.tolerancia.strftime("%d/%m/%Y %H:%M")
                    error.append('codigoticket')
        if fail is False:
            if request.POST.items():
                if '_addanother' or '_save' in request.POST:
                    agora = datetime.now()
                    #return HttpResponseRedirect("/pagamento/")
                    dictRetorno['class_msg'] = 'pnlSucesso grp-info'
                    dictRetorno['mensagem'] = u'Ticket "%s": pago com sucesso!' % retorno['codigoticket']
                    dictRetorno['error'] = None
                    dictRetorno['retorno'] = retorno
                    dictRetorno['placa'] = None
                    dictRetorno['ticket'] = None
                    dictRetorno['fidelidadeid'] = None
                    dictRetorno['acionamento'] = None
                    dictRetorno['vFormaPagamento'] = vFormaPagamento
                    dictRetorno['vFormaPagamentoRetorno'] = None
                    # from ihx.access.core.MODEquipamento.models import equipamento
                    # qsEquipamento = equipamento.objects.filter(equipamentodescricao__icontains='Saída')
                    # if qsEquipamento.exists():
                        # qsEquipamento = qsEquipamento[0]
                        # dictRetorno['acionamento'] = "%s;%s" % (str(qsEquipamento.equipamentotcpip), '1')
                    vTicket.dateupdate = agora
                    vTicket.userupdate = request.user.id
                    vTicket.dtpagamento = agora
                    if retorno['tolerancia_ticket'] == "None":
                        retorno['tolerancia_ticket'] = "00:00:00"
                    vTicket.tolerancia = functions.incresing_time(agora, retorno['tolerancia_ticket'])
                    vTicket.placa = retorno['placa']
                    if retorno['fidelidadeid']:
                        vTicket.fidelidadeid_id = int(retorno['fidelidadeid'])

                    if vTicket.valororiginal is None:
                        vTicket.valororiginal = 0
                    vTicket.valororiginal = float(retorno['valor_ticket'].replace(',', '.'))
                    if 'multiploacessodia' in request.POST.keys():
                        vTicket.multiploacessodia = True

                    if vTicket.valorrealizado is None:
                        vTicket.valorrealizado = 0
                    vTicket.valorrealizado = float(vTicket.valorrealizado) + float(retorno['valor_ticket'].replace(',', '.'))

                    #dados do movimento financeiro
                    from ihx.access.core.MODFinanceiro.models import finmovimento as app_finmovimento, finplanoconta, fincontacorrente
                    from ihx.access.core.MODEmpresa.models import empresa
                    #plano contas - pagamento rotativo 'Recebimento Rotativo'
                    planoConta = finplanoconta.objects.get(descricao='Recebimento Rotativo')
                    contaCorrente = fincontacorrente.objects.filter(contacaixa=True)
                    if contaCorrente.count() > 0:
                        contaCorrente = contaCorrente[0]
                    #Crio movimento financeiro
                    movimento = app_finmovimento(userinsert=request.user.id, dateinsert=vAgora, finplanocontaid=planoConta, receita=1, valido=1)
                    movimento.fincontacorrenteid = contaCorrente
                    #seto a empresa MATRIZ como default
                    movimento.pessoaid = empresa.objects.get(empresamatriz=True)

                    #movimento.contratoid = self.contratoid
                    movimento.dtvencimento = vAgora
                    movimento.valormovimento = retorno['valor_ticket'].replace(',', '.')
                    movimento.tipopagamento = retorno['forma_pagamento']

                    movimento.movimentoquitado = True
                    movimento.valorpagamento = retorno['valor_ticket'].replace(',', '.')
                    movimento.userupdate = request.user.id
                    movimento.dateupdate = vAgora
                    movimento.dtpagamento = vAgora

                    #Salvo Ticket
                    vTicket.permanencia = vTicket.dtpagamento.replace(microsecond=0) - vTicket.dtemissao.replace(microsecond=0)
                    vTicket.permanenciaminutos = int(vTicket.permanencia.total_seconds()) / 60
                    vTicket.save()
                    #Salvo Movimento
                    movimento.descricao = u'Ticket quitado: %s | Valor Ticket: %s | Valor Pago: %s | Valor Troco: %s' % (
                                          unicode(vTicket), unicode(retorno['valor_ticket']), unicode(vValorPago),
                                          unicode(float(vValorPago) - float(retorno['valor_ticket'].replace(',', '.')))
                                          )
                    movimento.descricao = movimento.descricao[:100]
                    movimento.prkticketid = vTicket
                    movimento.save()

                    #adicionar log do admin
                    dictRetorno['movID'] = str(movimento.pk)
                    LogEntry.objects.log_action(
                                user_id=request.user.id,
                                content_type_id=ContentType.objects.get_for_model(prkticket).pk,
                                object_id=vTicket.pk,
                                object_repr=u'Ticket quitado: %s | Valor Ticket: %s | Valor Pago: %s | Valor Troco: %s' % (
                                                                            unicode(vTicket), unicode(retorno['valor_ticket'].replace(',', '.')), unicode(vValorPago),
                                                                            unicode(float(vValorPago) - float(retorno['valor_ticket'].replace(',', '.')))
                                                                                                                                    ),
                                change_message=u'Pagamento efetuado',
                                action_flag=CHANGE
                    )
                    #garanto que o processo sera gerado dentro de uma unica transacao
                    transaction.commit()

        dictRetorno['TEMPLATE_URL'] = settings.TEMPLATE_URL
        if fail:
            dictRetorno['class_msg'] = 'errornote'
            dictRetorno['mensagem'] = u'Erro ao efetuar o pagamento do "%s" ' % mensagem
            dictRetorno['error'] = error
            dictRetorno['retorno'] = retorno
            dictRetorno['troco'] = retorno['troco']
            dictRetorno['placa'] = retorno['placa']
            dictRetorno['ticket'] = retorno['codigoticket']
            dictRetorno['fidelidadeid'] = retorno['fidelidadeid']
            dictRetorno['acionamento'] = None
            dictRetorno['vFormaPagamento'] = vFormaPagamento
            dictRetorno['vFormaPagamentoRetorno'] = retorno['forma_pagamento']

        if primeira_entrada:
            retorno = None
            dictRetorno['class_msg'] = None
            dictRetorno['mensagem'] = u""
            dictRetorno['error'] = None
            dictRetorno['retorno'] = None
            dictRetorno['vFormaPagamento'] = vFormaPagamento
            dictRetorno['vFormaPagamentoRetorno'] = None
            dictRetorno['placa'] = None
            dictRetorno['ticket'] = None
            if args:
                dictRetorno['ticket'] = args[0]
            dictRetorno['fidelidadeid'] = None
            dictRetorno['acionamento'] = None

        return render(
            request, 'pagamento_view.html', dictRetorno,
        )
    except:
        import sys
        #mensagem de erro padrão
        #cancelo a transacao
        transaction.rollback()
        if sys.exc_info():
            mensagem = u"%s" % sys.exc_info()[1]
        dictRetorno['class_msg'] = 'errornote'
        dictRetorno['mensagem'] = u'Erro ao efetuar o pagamento do "%s" ' % mensagem
        dictRetorno['error'] = error
        dictRetorno['retorno'] = retorno
        dictRetorno['troco'] = retorno['troco']
        dictRetorno['placa'] = retorno['placa']
        dictRetorno['ticket'] = retorno['codigoticket']
        dictRetorno['fidelidadeid'] = retorno['fidelidadeid']

        return render(request, 'pagamento_view.html', dictRetorno, )


@csrf_exempt
def add_tarifa(request, *args):
    vRetorno = ''
    vUltimo_tempo1 = '00:01'

    vUltimo_tempo1 = calc_ultimo_tempo(request, request.POST['tempo2'], 'Interno')

    valor = request.POST['valor'].replace(".", "").replace(",", ".")

    vRetorno = request.POST['tempo1'] + u'<separador>' + request.POST['tempo2'] + u'<separador>' + valor + u'<separador>' + request.POST['tipotarifatempo']
    vRetorno += u'<separador>' + str(vUltimo_tempo1) + u'<separador>' + request.POST['fracaotempo'] + u'<separador>' + request.POST['qtdfracao_tempo']
    vRetorno += u'<separador>' + request.POST['repetecobranca'] + u'<separador>' + request.POST['qtdfracao_repetecobranca']

    return HttpResponse(vRetorno, mimetype=None, content_type="text/html")


def calc_ultimo_tempo(request, *args):
    ultimo_tempo1 = '00:01'
    if args[0]:
        hoje = datetime.now()
        vTempo1 = args[0].split(':')

        if len(vTempo1) == 2:

            vHora = int(vTempo1[0])
            vMinuto = int(vTempo1[1])

            #Validacao para verificar se passou de meia noite
            delta = timedelta(hours=vHora, minutes=(vMinuto + 1))
            if delta.days <= 0:
                if vMinuto == 59:
                    vMinuto = 0
                    if vHora <= 23:
                        vHora = vHora + 1
                else:
                    vMinuto = vMinuto + 1
                #crio a datatime com o novo horario
                vProx_Tempo1 = datetime(hoje.year, hoje.month, hoje.day, vHora, vMinuto, 0)
                ultimo_tempo1 = vProx_Tempo1.strftime("%H:%M")
            else:
                ultimo_tempo1 = "23:59"
        if 'Interno' in args:
            return ultimo_tempo1
        else:
            return HttpResponse(ultimo_tempo1)
    return HttpResponse(ultimo_tempo1)


@csrf_exempt
def calcula_valor_ticket(request, *args):
    from app.modules.MODTarifa import models
    from django.db.models import Q
    import json
    teste_tarifa = False
    if request.POST:
        teste_tarifa = True
    cAno = 2011
    cMes = 1
    cDia = 2
    #variáveis de retorno ::: JSON

    #tolerancia = saida, tolerancia_entrada = configuracao da tolerancia de entrada para ignorar o calculo
    from ihx.access.core.MODConfiguracao.models import current_config
    vConfGeral = current_config()
    tolerancia = time(0, 0, 0, 0)
    vToleranciaEntrada = timedelta(minutes=0)
    if vConfGeral.prktoleranciaentrada:
        vToleranciaEntrada = timedelta(minutes=vConfGeral.prktoleranciaentrada)

    valor_ticket = 0
    status = False
    mensagem = ""
    vPlaca = ""
    vMsgDesconto = u"NENHUM"
    vTarifaDescricao = u'Tarifa não encontrada!'
    vMultiploacessodia = False
    vUltimaTarifa = None
    vValorMaximoDia = 0
    agora = datetime.combine(datetime.now().date(), datetime.now().time())
    vMesmoDia = False
    tarifa_padrao = None
    vTempoPermanenciaTela = ""
    vFidelidadeid = 0
    dtemissao = datetime.now().strftime("%d/%m/%Y")
    horaemissao = "00:00"
    vValorRealizado = 0

    #obternho a tolerancia da 1ª tarifa para caso não localize nenhuma
    try:
        tarifa_padrao = models.prktarifa.objects.filter(ativa=1)
        if tarifa_padrao.count() > 0:
            tarifa_padrao = tarifa_padrao[0]
            tolerancia = tarifa_padrao.tolerancia
    except:
        mensagem = u"TARIFA não cadastrada!!!"
        #data = {'torelerancia': str(tolerancia), 'valor_ticket': "%.2f" % valor_ticket, 'status': False, 'mensagem': mensagem}
        data = {
            'placa': vPlaca,
            'torelerancia': str(tolerancia),
            'valor_ticket': "%.2f" % valor_ticket,
            'status': False,
            'mensagem': mensagem,
            'desconto': vMsgDesconto.upper(),
            'permanencia': vTempoPermanenciaTela,
            'dtemissao': dtemissao,
            'tarifa': vTarifaDescricao,
            'multiploacessodia': vMultiploacessodia,
            'mesmoDia': vMesmoDia,
            'valorDiaria': "%.2f" % vValorMaximoDia,
            'horaemissao': horaemissao,
            'fidelidadeid': vFidelidadeid,
            'valorrealizado': "%.2f" % vValorRealizado
        }
        return HttpResponse(json.dumps(data), mimetype='application/json')

    #recebendo o ticket como paramentro
    vTicket = args[0].strip()

    vObjDesconto = None

    try:
        #buscando a permanencia
        qs_ticket = models.prkticket.objects.filter(codigo=vTicket, valido=True)

        if teste_tarifa is False:
            if qs_ticket.count() == 0:
                mensagem = u"Ticket não cadastrado."
                #data = {'torelerancia': str(tolerancia), 'valor_ticket': "%.2f" % valor_ticket, 'status': False, 'mensagem': mensagem}
                data = {
                    'placa': vPlaca,
                    'torelerancia': str(tolerancia),
                    'valor_ticket': "%.2f" % valor_ticket,
                    'status': False,
                    'mensagem': mensagem,
                    'desconto': vMsgDesconto.upper(),
                    'permanencia': vTempoPermanenciaTela,
                    'dtemissao': dtemissao,
                    'tarifa': vTarifaDescricao,
                    'multiploacessodia': vMultiploacessodia,
                    'mesmoDia': vMesmoDia,
                    'valorDiaria': "%.2f" % vValorMaximoDia,
                    'horaemissao': horaemissao,
                    'fidelidadeid': vFidelidadeid,
                    'valorrealizado': "%.2f" % vValorRealizado
                }
                return HttpResponse(json.dumps(data), mimetype='application/json')
            else:
                obj_ticket = qs_ticket[0]
                vPlaca = obj_ticket.placa.upper() if not obj_ticket.placa is None else obj_ticket.placa
                if obj_ticket.multiploacessodia:
                    vMultiploacessodia = obj_ticket.multiploacessodia

            #if obj_ticket.dtpagamento:
                #mensagem = u"O Ticket já foi pago."
                #data = {'torelerancia': str(tolerancia), 'valor_ticket': "%.2f" % valor_ticket, 'status': False, 'mensagem': mensagem}
                #return HttpResponse(json.dumps(data), mimetype='application/json')

        #Coloco os valores para teste
        if teste_tarifa:
            vEmissao = functions.str_to_datetime(request.POST['dt_inicio'] + ' ' + request.POST['hora_inicio'])
            agora = functions.str_to_datetime(request.POST['dt_fim'] + ' ' + request.POST['hora_fim'])
            if request.POST['fidelidadeid']:
                vObjDesconto = planofidelidade.objects.filter(pk=request.POST['fidelidadeid'])[0]
        else:

            vEmissao = obj_ticket.dtemissao
            if 'fidelidadeid' in request.GET:
                if request.GET['fidelidadeid']:
                    vObjDesconto = planofidelidade.objects.filter(pk=request.GET['fidelidadeid'])[0]

            if vObjDesconto is None:
                vObjDesconto = obj_ticket.fidelidadeid
            #aaa=a
        #Verifico se data de emissão é maior que data atual
        vPermanencia = agora - vEmissao

        #Verifico se data de emissão é na mesma data atual
        vMesmoDia = vEmissao.date() == agora.date()
        if (vPermanencia.days < 0):
            mensagem = u"A data de emissão do ticket é maior que a data atual."
            #data = {'torelerancia': str(tolerancia), 'valor_ticket': "%.2f" % valor_ticket, 'status': status, 'mensagem': mensagem}
            data = {
                'placa': vPlaca,
                'torelerancia': str(tolerancia),
                'valor_ticket': "%.2f" % valor_ticket,
                'status': status,
                'mensagem': mensagem,
                'desconto': vMsgDesconto.upper(),
                'permanencia': vTempoPermanenciaTela,
                'dtemissao': dtemissao,
                'tarifa': vTarifaDescricao,
                'multiploacessodia': vMultiploacessodia,
                'mesmoDia': vMesmoDia,
                'valorDiaria': "%.2f" % vValorMaximoDia,
                'horaemissao': horaemissao,
                'fidelidadeid': vFidelidadeid,
                'valorrealizado': "%.2f" % vValorRealizado
            }
            return HttpResponse(json.dumps(data), mimetype='application/json')

        #calculo de desconto....
        vDesconto = 0
        vFidelidadeid = 0
        #tipos de desconto
        #    1  - Valor fixo
        #    2  - Percentual
        #    3  - Minutos
        #....4  - Valor Maximo
        #    99 - Gratuito
        if vObjDesconto:
            vDesconto = vObjDesconto.tipodesconto
            vMsgDesconto = u"%s" % vObjDesconto.descricao
            vFidelidadeid = vObjDesconto.id

        # desconto Gratuito
        if vDesconto == 99:
            #vDesconto = u"Ticket gratuíto."
            #data = {'torelerancia': str(tolerancia), 'valor_ticket': "0,00", 'status': True, 'mensagem': mensagem, 'desconto': vMsgDesconto, 'multiploacessodia': vMultiploacessodia, }
            data = {
                'placa': vPlaca,
                'torelerancia': str(tolerancia),
                'valor_ticket': "0,00",
                'status': True,
                'mensagem': mensagem,
                'desconto': vMsgDesconto.upper(),
                'permanencia': vTempoPermanenciaTela,
                'dtemissao': dtemissao,
                'tarifa': vTarifaDescricao,
                'multiploacessodia': vMultiploacessodia,
                'mesmoDia': vMesmoDia,
                'valorDiaria': "%.2f" % vValorMaximoDia,
                'horaemissao': horaemissao,
                'fidelidadeid': vFidelidadeid,
                'valorrealizado': "%.2f" % vValorRealizado
            }
            return HttpResponse(json.dumps(data), mimetype='application/json')

        vFiltroDiaSemana = [{"seg": 1}, {"ter": 1}, {"qua": 1}, {"qui": 1}, {"sex": 1}, {"sab": 1}, {"dom": 1}]
        array_dias = range(vPermanencia.days + 1)

        for i in array_dias:
            dia = vEmissao + timedelta(days=i)
            hora_inicio = datetime(cAno, cMes, cDia, 0, 0, 0, 0)
            hora_final = datetime(cAno, cMes, cDia, 23, 59, 59, 0)

            #indice 0 é a data de impressão do ticket
            if (i == 0):
                hora_inicio = datetime.combine(hora_inicio.date(), vEmissao.time())

            #o ultimo dia do array é hoje
            if i == array_dias[len(array_dias) - 1]:
                hora_final = datetime.combine(hora_final.date(), agora.time())
                hora_inicio = datetime.combine(hora_final.date(), vEmissao.time())
                if agora.time() < vEmissao.time():
                    hora_inicio = datetime.combine(datetime(cAno, cMes, cDia).date(), vEmissao.time())

            if (hora_inicio > hora_final):
                hora_inicio = datetime(cAno, cMes, cDia - 1, 0, 0, 0, 0)
                hora_inicio = datetime.combine(hora_inicio.date(), vEmissao.time())

            ##calcula tempo de permanencia
            tempo_permanencia = hora_final - hora_inicio
            #realizo a conta da faixa
            vSegundo = int(tempo_permanencia.total_seconds())
            #verifico se tem fidelidade em minutos
            if vDesconto == 3:
                vSegundo -= vObjDesconto.valor * 60
                if vSegundo < 0:
                    vSegundo = 0

            vHora = int(vSegundo / 3600)
            vSegundo -= (vHora * 3600)
            vMinuto = int(vSegundo / 60)
            vSegundo -= (vMinuto * 60)
            tempo_permanencia_dttime = datetime(cAno, cMes, cDia, vHora, vMinuto, vSegundo, 0)

            qs_vigencia = models.prkvigencia.objects.filter(**vFiltroDiaSemana[dia.weekday()])
            qs_vigencia = qs_vigencia.filter(Q(tempo1__lte=hora_inicio.time(), tempo2__gte=hora_inicio.time()) | Q(tempo1__lte=hora_final.time(), tempo2__gte=hora_final.time()))

            for vigencia in qs_vigencia:
                if teste_tarifa:
                    qs_tarifa = models.prktarifa.objects.filter(prkvigenciaid=vigencia.pk, ativa=1, classe_id__descricao='Todos os veículos')
                else:
                    qs_tarifa = models.prktarifa.objects.filter(prkvigenciaid=vigencia.pk, ativa=1, classe=obj_ticket.classe)
                if (qs_tarifa.count() == 0):
                    continue
                if (qs_tarifa.count() > 1):
                    mensagem = u"Não foi possível identificar a tarifação ativa.\nTotal de tabelas encontradas: %s " % qs_tarifa.count()
                    #data = {'torelerancia': str(tolerancia), 'valor_ticket': "%.2f" % valor_ticket, 'status': status, 'mensagem': mensagem}
                    data = {
                        'placa': vPlaca,
                        'torelerancia': str(tolerancia),
                        'valor_ticket': "%.2f" % valor_ticket,
                        'status': status,
                        'mensagem': mensagem,
                        'desconto': vMsgDesconto.upper(),
                        'permanencia': vTempoPermanenciaTela,
                        'dtemissao': dtemissao,
                        'tarifa': vTarifaDescricao,
                        'multiploacessodia': vMultiploacessodia,
                        'mesmoDia': vMesmoDia,
                        'valorDiaria': "%.2f" % vValorMaximoDia,
                        'horaemissao': horaemissao,
                        'fidelidadeid': vFidelidadeid,
                        'valorrealizado': "%.2f" % vValorRealizado
                    }
                    return HttpResponse(json.dumps(data), mimetype='application/json')

                obj_tarifa = qs_tarifa[0]
                vTarifaDescricao = obj_tarifa.descricao

                #Armazeno o valor maximo da tarifa (Pagar Diária)
                if obj_tarifa.valormaximo:
                    vValorMaximoDia = obj_tarifa.valormaximo

                if (i == 0) and (vPermanencia.days > 0):
                    if obj_tarifa.valormaximo:
                        valor_ticket += float(obj_tarifa.valormaximo)
                    continue
                # tabela de preço fixo
                if obj_tarifa.tipotarifa == 2:
                    #combino data de hoje + hora para comprar o datetime abaixo
                    dt = datetime.combine(datetime.today(), time(0, 0)) + vToleranciaEntrada
                    #combino data de hoje + vPermanencia para comprar o datetime abaixo
                    dttotal = datetime.combine(datetime.today(), time(0, 0)) + vPermanencia

                    if dttotal.time() <= dt.time() and i == 0:
                        valor_tabela = 0
                        break;
                    else:
                        valor_ticket += float(obj_tarifa.tarifaunica)
                else:
                    #INLINE/ Ultimo campo de calculo
                    qs_valor = models.prkvalor.objects.filter(tarifaid=obj_tarifa.pk)
                    valor_tabela = 0
                    obj_valor = None

                    #combino data de hoje + hora para comprar o datetime abaixo
                    dt = datetime.combine(datetime.today(), time(0, 0)) + vToleranciaEntrada
                    #combino data de hoje + vPermanencia para comprar o datetime abaixo
                    dttotal = datetime.combine(datetime.today(), time(0, 0)) + vPermanencia

                    if dttotal.time() <= dt.time() and i == 0:
                        valor_tabela = 0
                        break

                    for obj_valor in qs_valor:
                        vCalcFaixa = 0
                        #realizo a conta da faixa
                        vTempo1 = datetime.combine(hora_inicio.date(), obj_valor.tempo1)
                        vTempo2 = datetime.combine(hora_inicio.date(), obj_valor.tempo2)

                        if obj_valor.tempo1 > tempo_permanencia_dttime.time():
                            continue

                        #se não é para acumular os valores entre as faixas, eu zero a conta
                        if not obj_valor.acumulacobranca:
                            valor_tabela = 0

                        #verifico se usou a faixa integralmente
                        if tempo_permanencia_dttime > vTempo2:
                            vCalcFaixa += obj_valor.valor
                        else:
                            if obj_valor.fracaotempo:
                                fracao_tempo = tempo_permanencia_dttime - vTempo1
                                tempo_faixa = vTempo2 - vTempo1
                                num_partes = (fracao_tempo.seconds / (tempo_faixa / obj_valor.qtdfracaotempo).seconds) + 1
                                vCalcFaixa += (obj_valor.valor * num_partes) / obj_valor.qtdfracaotempo

                            else:
                                vCalcFaixa += obj_valor.valor

                        valor_tabela += vCalcFaixa
                        #se o valor ´do calculo da tabela é maior que o valor maximo, eu considero o valor maximo
                        if obj_tarifa.valormaximo:
                            if valor_tabela > obj_tarifa.valormaximo:
                                valor_tabela = obj_tarifa.valormaximo
                                break
                    #conta da ultima faixa
                    #adiciono o valor calculado para a tabela no valor final do ticket
                    if valor_tabela is None or valor_tabela == 0:
                        valor_tabela = 0
                    # caso a permanencia seja maior que o tempo final da ultima faixa, considero as regras de após o ultimo horario
                    tempo_permanencia_dttime = datetime(cAno, cMes, cDia, vHora, vMinuto, 0, 0)

                    if (obj_valor is None) or (obj_valor.tempo2 < tempo_permanencia_dttime.time()):
                        vHora = tempo_permanencia_dttime
                        if (obj_valor is not None):
                            vHora -= datetime.combine(tempo_permanencia_dttime.date(), obj_valor.tempo2)
                            vSegundo = int(vHora.total_seconds())
                            vHoraConvert = int(vSegundo / 3600)
                            vSegundo -= (vHoraConvert * 3600)
                            vMinuto = int(vSegundo / 60)
                            vSegundo -= (vMinuto * 60)
                            vHora = datetime(cAno, cMes, cDia, vHoraConvert, vMinuto, vSegundo, 0)
                        vQtde = 1
                        import math
                        if obj_tarifa.aposqtdrepetecobrancatempo:
                            vQtde = float((vHora.hour * 60) + vHora.minute) / obj_tarifa.aposqtdrepetecobrancatempo
                        valor_tabela = float(valor_tabela) + (float(obj_tarifa.aposvalor) * math.ceil(vQtde))

                        #se o valor do calculo da tabela é maior que o valor maximo, eu considero o valor maximo
                        if obj_tarifa.valormaximo:
                            if valor_tabela > obj_tarifa.valormaximo:
                                valor_tabela = obj_tarifa.valormaximo
                    valor_ticket = float(valor_ticket) + float(valor_tabela)

                vUltimaTarifa = obj_tarifa
        status = True
        mensagem = u"Calculo realizado com sucesso."

        vTempoPermanenciaTela = ""
        if vPermanencia.days > 0:
            vPermanenciaSplit = str(vPermanencia).split(",")
            vTempoPermanenciaTela = vPermanenciaSplit[1].split(".")
            vTempoPermanenciaTela = vTempoPermanenciaTela[0].strip()
            vTempoPermanenciaTela = '%s Dias, %s' % (vPermanencia.days, vTempoPermanenciaTela)
        else:
            vTempoPermanenciaTela = str(vPermanencia).split(".")
            vTempoPermanenciaTela = vTempoPermanenciaTela[0].strip()
            vTempoPermanenciaTela = '%s' % (vTempoPermanenciaTela)

        if vUltimaTarifa:
            if vUltimaTarifa.tolerancia:
                tolerancia = vUltimaTarifa.tolerancia
        dtemissao = vEmissao.strftime("%d/%m/%Y")
        horaemissao = vEmissao.strftime("%H:%M")

        #Desconto...
        if vDesconto == 1:
            valor_ticket -= float(vObjDesconto.valor)

        if vDesconto == 2:
            valor_ticket = float(valor_ticket) - (valor_ticket * (float(vObjDesconto.valor) / 100))

        #desconto valor maximo
        if vDesconto == 4:
            valor_desconto = float(vObjDesconto.valor)
            valor_ticket = valor_desconto

        vValorRealizado = 0
        if teste_tarifa is False:
            #verifico se já teve algum valor pago anteriormente
            if obj_ticket.valorrealizado:
                vValorRealizado = float(obj_ticket.valorrealizado)
                valor_ticket -= float(obj_ticket.valorrealizado)

        if valor_ticket < 0:
            valor_ticket = 0
            mensagem = u"O valor do desconto maior que o Valor do ticket"

        data = {
                'placa': vPlaca,
                'torelerancia': str(tolerancia),
                'valor_ticket': "%.2f" % valor_ticket,
                'status': status,
                'mensagem': mensagem,
                'desconto': vMsgDesconto.upper(),
                'permanencia': vTempoPermanenciaTela,
                'dtemissao': dtemissao,
                'tarifa': vTarifaDescricao,
                'multiploacessodia': vMultiploacessodia,
                'mesmoDia': vMesmoDia,
                'valorDiaria': "%.2f" % vValorMaximoDia,
                'horaemissao': horaemissao,
                'fidelidadeid': vFidelidadeid,
                'valorrealizado': "%.2f" % vValorRealizado
                }
    except:
        import sys
        data = {
            'valor_ticket': "erro",
            'status': False,
            'mensagem': "ERROR AO CALCULAR A TARIFA: %s" % (sys.exc_info()[1])
        }
    return HttpResponse(json.dumps(data), mimetype='application/json')


@csrf_exempt
def gerar_ticket_view(request, *args):
    classificacao = ''
    error = []
    mensagem = u''
    dictRetorno = {}
    fail = False
    primeira_entrada = True
    retorno = request.POST

    if retorno:
        primeira_entrada = False
    for key, item in request.POST.items():
        if (key in ['classe']) and item == '':
            fail = True
            mensagem = u"o campo %s é obrigatório" % key.upper()
            error.append(key)

    if fail is False:
        if request.POST.items():
            if 'placa' in request.POST:
                placa = request.POST['placa'].upper()
            if 'classe' in request.POST:
                if request.POST['classe']:
                    classificacao = prktarifaclasse.objects.get(pk=request.POST['classe'])
            if 'gerar_ticket' in request.POST:
                vTicket = gerar_ticket(request, placa, classificacao)
                dictRetorno['class_msg'] = 'pnlSucesso grp-info'
                dictRetorno['mensagem'] = u'Ticket "%s": gerado com sucesso!' % vTicket
                dictRetorno['error'] = None
                dictRetorno['retorno'] = retorno
                dictRetorno['placa'] = None
                dictRetorno['fidelidadeid_id'] = None
                dictRetorno['acionamento'] = None
                # from ihx.access.core.MODEquipamento.models import equipamento
                # qsEquipamento = equipamento.objects.filter(equipamentodescricao__icontains='Entrada')
                # if qsEquipamento.exists():
                    # qsEquipamento = qsEquipamento[0]
                    # dictRetorno['acionamento'] = "%s;%s" % (str(qsEquipamento.equipamentotcpip), '0')

                newTicket = prkticket(codigo=vTicket, valido=True, dtemissao=datetime.now())
                if classificacao:
                    newTicket.classe = classificacao
                    newTicket.placa = placa
                newTicket.save()
                #Adicionar log do admin
                LogEntry.objects.log_action(
                            user_id=request.user.id,
                            content_type_id=ContentType.objects.get_for_model(prkticket).pk,
                            object_id=newTicket.pk,
                            object_repr=u'Ticket gerado : ' + unicode(newTicket),
                            action_flag=ADDITION
                )

    dictRetorno['TEMPLATE_URL'] = settings.TEMPLATE_URL
    if fail:
        dictRetorno['class_msg'] = 'errornote'
        dictRetorno['mensagem'] = u'Erro ao gerar o Ticket "%s"' % mensagem
        dictRetorno['error'] = error
        dictRetorno['retorno'] = retorno
        dictRetorno['placa'] = retorno['placa']
        dictRetorno['acionamento'] = None

    if primeira_entrada:
        retorno = None
        dictRetorno['class_msg'] = None
        dictRetorno['mensagem'] = u""
        dictRetorno['error'] = None
        dictRetorno['retorno'] = None
        dictRetorno['acionamento'] = None

    return render_to_response(
        'gerar_ticket_view.html', dictRetorno,
    )


@csrf_exempt
def get_convenio_ticket(request, *args):
    vTicket = args[0]
    data = {
        'desconto': None,
        'status': False,
        'mensagem': ""
    }
    #buscando a permanencia
    from app.modules.MODTarifa import models
    import json
    qs_ticket = models.prkticket.objects.filter(codigo=vTicket, valido=True)

    if qs_ticket.count() == 0:
        data['mensagem'] = u"Ticket não cadastrado."
        data['status'] = False
    else:
        obj_ticket = qs_ticket[0]
        data['status'] = True
        data['id_desconto'] = None
        if obj_ticket.fidelidadeid_id:
            data['id_desconto'] = obj_ticket.fidelidadeid_id

    return HttpResponse(json.dumps(data), mimetype='application/json')


def gerar_ticket(request, *args):
    vIP = get_machine_ip()
    vsplit_ip = vIP.split('.')
    vLast_ip = vsplit_ip[len(vsplit_ip) - 1].zfill(3)
    vTicket = '%s%s' % (vLast_ip, datetime.now().strftime('%y%m%d%H%M%S'))
    vTicket = vTicket + str(int(vTicket) % 10)
    #gerar_ticket_impresso(vTicket, args)
    return vTicket


def get_machine_ip():
    import socket
    hostname = socket.gethostname()
    IP = socket.gethostbyname(hostname)
    return IP

width = 7.8 * cm
height = 10 * cm
left = 1.8 * cm
margin_top = 2.4 * cm
line_height = 0.4 * cm
fontname = "Courier"


def linha(value):
    top = height - margin_top
    top -= line_height * value
    return top


def gerar_ticket_impresso(aTicket, args):
    from reportlab.pdfgen import canvas
    #from reportlab.lib.pagesizes import A4
    from reportlab.graphics.barcode.common import I2of5
    vMensagens = prkticket_mensagem.objects.get(pk=1)
    #Altura, Largura
    c = canvas.Canvas(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + aTicket + ".pdf", pagesize=(height, width))

    c.setFont(fontname, 8)
    c.drawString(left, linha(1), 'IHX Sistemas')
    c.drawString(left, linha(2), vMensagens.linha1)
    c.drawString(left, linha(3), vMensagens.linha2)
    c.drawString(left, linha(4), vMensagens.linha3)
    c.drawString(left, linha(5), vMensagens.linha4)
    #c.drawString(left, linha(2), 'Não deixe este ticket no veículo')
    #c.drawString(left, linha(3), 'Preserve a natureza!')
    #c.drawString(left, linha(4), 'Não jogue este ticket no chão!')
    #c.drawString(left, linha(5), '')
    c.setFont(fontname, 12)
    c.drawString(left, linha(6), "Placa: " + str(args[0]).upper())
    c.setFont(fontname, 8)

    # thin bar
    tb = 0.254320987654 * cm
    # bar height
    bh = 3.1 * cm
    # barcode length
    bcl = 5.3 * cm
    bc = I2of5(aTicket, barWidth=tb, ratio=3, barHeight=bh, bearers=0, quiet=0, checksum=0, humanReadable=0)
    # Adjust the width
    tb = (tb * bcl) / bc.width
    bc.__init__(aTicket, barWidth=tb)
    c.setFont(fontname, 10)
    # Render the bc image 5mm from bottom of the page.
    bc.drawOn(c, left + 0.47 * cm, linha(7) - bh)

    c.setFont(fontname, 8)

    c.drawString(left, linha(16), 'Ticket                %s' % str(aTicket))
    c.drawString(left, linha(17), 'Data                        %s' % datetime.now().strftime("%d/%m/%Y"))
    c.drawString(left, linha(18), 'Hora                          %s' % datetime.now().strftime("%H:%M:%S"))

    c.showPage()
    c.save()

    import os
    os.startfile(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + aTicket + ".pdf", "print")
    #os.startfile("D:/projetos/sites/IHX_Parking/pdf/" + aTicket + ".pdf", "print")
    #import time
    #aguardo 10 segundos ate que seja enviado para buffer da impressora, depois removo o arquivo
    #time.sleep(10)
    #os.remove(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + aTicket + ".pdf")
    return c


@csrf_exempt
def testar_tarifa(request, *args):
    #classificacao = ''
    #error = []
    #mensagem = u''
    dictRetorno = {}
    #fail = False
    #primeira_entrada = True
    #retorno = request.POST

    dictRetorno['TEMPLATE_URL'] = settings.TEMPLATE_URL
    #if fail:
        #dictRetorno['class_msg'] = 'errornote'
        #dictRetorno['mensagem'] = u'Erro ao gerar o Ticket "%s"' % mensagem
        #dictRetorno['error'] = error
        #dictRetorno['retorno'] = retorno
        #dictRetorno['placa'] = retorno['placa']

    #if primeira_entrada:
    #retorno = None
    dictRetorno['class_msg'] = None
    dictRetorno['mensagem'] = u""
    dictRetorno['error'] = None
    dictRetorno['retorno'] = None

    return render_to_response(
        'testar_tarifa.html', dictRetorno,
    )


def imprimir_ticket(request, *args):
    import os
    os.startfile(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + args[0] + ".pdf", "open")
    return HttpResponseRedirect(request.META['HTTP_REFERER'])


def ticket_impresso(request, *args):
    vMensagens = prkticket_mensagem.objects.get(pk=1)
    dictRetorno = {}
    #dictRetorno['Ticket'] = None
    if args:
        vTicket = None
        if prkticket.objects.filter(codigo=args[0]).exists():
            vTicket = prkticket.objects.filter(codigo=args[0])[0]
        dictRetorno['Ticket'] = vTicket
    dictRetorno['TEMPLATE_URL'] = settings.TEMPLATE_URL
    dictRetorno['vMensagens'] = vMensagens
    dictRetorno['ADMIN_TITLE'] = settings.ADMIN_TITLE
    return render_to_response(
        'ticket_impresso.html', dictRetorno,
    )


def imprimir_ticket2(request, *args):
    #import os
    #os.startfile(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + args[0] + ".pdf", "open")
    with open(settings.RAIZ + settings.MEDIA_URL + "/pdf/" + args[0] + ".pdf", 'r') as pdf:
        response = HttpResponse(pdf.read(), mimetype='application/pdf')
        response['Content-Disposition'] = 'attachment; filename="%s"' % '%s.pdf' % args[0]
        return response
    pdf.closed
    return response