# -*- coding: UTF-8 -*-

# Django settings for IHX_Access project.

DEBUG = True
TEMPLATE_DEBUG = DEBUG

ADMINS = (
    # ('Your Name', 'your_email@example.com'),
)

MANAGERS = ADMINS

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',  # Add 'postgresql_psycopg2', 'mysql', 'sqlite3' or 'oracle'.
        'NAME': 'ihx_parking',                 # Or path to database file if using sqlite3.
        'HOST': '127.0.0.1',             # Set to empty string for localhost. Not used with sqlite3.
        'USER': 'root',                      # Not used with sqlite3.
        'PASSWORD': '9TOn67p0mwk5ANzG',                # Not used with sqlite3.
        'PORT': '3306',                       # Set to empty string for default. Not used with sqlite3.
    }
}

# Local time zone for this installation. Choices can be found here:
# http://en.wikipedia.org/wiki/List_of_tz_zones_by_name
# although not all choices may be available on all operating systems.
# In a Windows environment this must be set to your system time zone.
TIME_ZONE = 'America/Sao_Paulo'

# Language code for this installation. All choices can be found here:
# http://www.i18nguy.com/unicode/language-identifiers.html

DIR_MEDIA = 'media'
DIR_TEMPLATE = 'templates'

LANGUAGE_CODE = 'pt-br'

SITE_ID = 1

# If you set this to False, Django will make some optimizations so as not
# to load the internationalization machinery.
USE_I18N = True

# If you set this to False, Django will not format dates, numbers and
# calendars according to the current locale.
USE_L10N = True

# If you set this to False, Django will not use timezone-aware datetimes.
USE_TZ = False

import os
RAIZ = os.path.dirname(os.path.abspath(__file__))

# Absolute filesystem path to the directory that will hold user-uploaded files.
# Example: "/home/media/media.lawrence.com/media/"
MEDIA_ROOT = os.path.join(RAIZ, DIR_MEDIA)
MEDIA_TEMPLATE = os.path.join(RAIZ, DIR_TEMPLATE)
# URL that handles the media served from MEDIA_ROOT. Make sure to use a
# trailing slash.
# Examples: "http://media.lawrence.com/media/", "http://example.com/media/"
MEDIA_URL = '/' + DIR_MEDIA + '/'
TEMPLATE_URL = '/' + DIR_TEMPLATE + '/'

# Absolute path to the directory static files should be collected to.
# Don't put anything in this directory yourself; store your static files
# in apps' "static/" subdirectories and in STATICFILES_DIRS.
# Example: "/home/media/media.lawrence.com/static/"
STATIC_ROOT = ''

# URL prefix for static files.
# Example: "http://media.lawrence.com/static/"
STATIC_URL = '/static/'

# Additional locations of static files
STATICFILES_DIRS = (
    # Put strings here, like "/home/html/static" or "C:/www/django/static".
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
)

# List of finder classes that know how to find static files in
# various locations.
STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
#    'django.contrib.staticfiles.finders.DefaultStorageFinder',
)

# Make this unique, and don't share it with anybody.
SECRET_KEY = 'rxyml3+)piy!@-b#v77*=$!fme#p7tp%uvtxb8b509w2rcd32='

# List of callables that know how to import templates from various sources.
TEMPLATE_LOADERS = (
    'django.template.loaders.filesystem.Loader',
    'django.template.loaders.app_directories.Loader',
#     'django.template.loaders.eggs.Loader',
)

MIDDLEWARE_CLASSES = (
    'django.middleware.common.CommonMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    # Uncomment the next line for simple clickjacking protection:
    # 'django.middleware.clickjacking.XFrameOptionsMiddleware',
)

ROOT_URLCONF = 'app.urls'

# Python dotted path to the WSGI application used by Django's runserver.
#WSGI_APPLICATION = 'app.wsgi.application'

TEMPLATE_DIRS = (
    # Put strings here, like "/home/html/django_templates" or "C:/www/django/templates".
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
    MEDIA_TEMPLATE,
    'C://Python27//Lib//site-packages//ihx//access//templates',
)

SESSION_EXPIRE_AT_BROWSER_CLOSE = True
# Sessão expira em 1 dia (86400 segundos)
SESSION_COOKIE_AGE = 86400

ADMIN_TITLE = u'IHX ::: Parking'
GRAPPELLI_ADMIN_TITLE = ADMIN_TITLE

TEMPLATE_CONTEXT_PROCESSORS = (
    "django.contrib.auth.context_processors.auth",
    "django.core.context_processors.request",
    "django.core.context_processors.i18n",
    "django.contrib.messages.context_processors.messages",
    "ihx.access.context_processors.admin_template",
    "ihx.access.context_processors.admin_title",
    "ihx.access.context_processors.licenca_valida",
    "ihx.access.context_processors.site_version",
    "ihx.access.context_processors.core_version",
    "ihx.access.context_processors.caracteres",
)

INSTALLED_APPS = (
    #application core
    'ihx.access',
    'ihx.access.base',
    'ihx.access.core.MODAcesso',
    'ihx.access.core.MODEquipamento',
    'ihx.access.core.MODRelatorio',
    'ihx.access.core.MODRefeitorio',
    'ihx.access.core.MODUsuario',
    'ihx.access.core.MODPessoa',
    'ihx.access.core.MODEmpresa',
    'ihx.access.core.MODManutencao',
    'ihx.access.core.MODVisita',
    'ihx.access.core.MODFinanceiro',
    #'ihx.access.core.MODVenda',
    'ihx.access.core.MODNotificacao',
    'ihx.access.core.MODConfiguracao',
    'ihx.access.core.MODEvento',
    'ihx.access.core.MODGestao',
    'ihx.access.core.MODControle',
    #application
    'app.modules',
    'app.modules.MODTarifa',
    'app.modules.MODControle',
    # 'app.modules.MODEmpresa',
    #django app and components
    'grappelli',
    'daterange_filter',
    #'django.contrib.sites',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.admin',
    'django.contrib.admindocs',
)

# A sample logging configuration. The only tangible logging
# performed by this configuration is to send an email to
# the site admins on every HTTP 500 error when DEBUG=False.
# See http://docs.djangoproject.com/en/dev/topics/logging for
# more details on how to customize your logging configuration.
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'filters': {
        'require_debug_false': {
            '()': 'django.utils.log.RequireDebugFalse'
        }
    },
    'handlers': {
        'mail_admins': {
            'level': 'ERROR',
            'filters': ['require_debug_false'],
            'class': 'django.utils.log.AdminEmailHandler'
        }
    },
    'loggers': {
        'django.request': {
            'handlers': ['mail_admins'],
            'level': 'ERROR',
            'propagate': True,
        },
    }
}

#Exibe Ação de remover biometrias
ac_remover_biometrias = False

#Configuracao para visita utilizar somente facial
useFacialVisita = False

#Exibe Data de vencimento no Painel de acesso
from ihx.access.core.MODAcesso import views
views.Exibir_dtVencimento_painel = True

#Configuraçao de visita rápida
from ihx.access.core.MODVisita import forms
forms.IsToRegister_VisitaRapida_Form = True
forms.IsToRegister_portaria_view = False
forms.ColetaCracha_Visita = True

# application constants
from django.utils.translation import ugettext as _
from ihx.access.base import constants
constants.gAPPLICATION_TITLE = _(ADMIN_TITLE)
constants.gLBL_EMPRESA = _(u'Empresa')
constants.gLBL_EMPRESAS = _(u'Empresas')